diff -Nrc2 fontutils-0.5/imageto/M.depend fontutils-0.6/imageto/M.depend
*** fontutils-0.5/imageto/M.depend	Wed Sep  2 17:20:53 1992
--- fontutils-0.6/imageto/M.depend	Sun Oct 25 14:16:07 1992
***************
*** 3,20 ****
    .././include/c-seek.h .././include/c-proto.h .././include/global.h .././include/lib.h \
    .././include/types.h .././include/bitmap.h .././include/bounding-box.h bitmap2.h 
- epsf.o : epsf.c .././include/config.h .././include/c-auto.h .././include/c-std.h \
-   .././include/c-memstr.h .././include/c-errno.h .././include/c-minmax.h .././include/c-limits.h \
-   .././include/c-seek.h .././include/c-proto.h .././include/global.h .././include/lib.h \
-   .././include/types.h .././include/hexify.h .././include/report.h epsf.h image-header.h \
-   main.h 
  extract.o : extract.c .././include/config.h .././include/c-auto.h .././include/c-std.h \
    .././include/c-memstr.h .././include/c-errno.h .././include/c-minmax.h .././include/c-limits.h \
    .././include/c-seek.h .././include/c-proto.h .././include/global.h .././include/lib.h \
!   .././include/types.h .././include/bitmap.h .././include/bounding-box.h bitmap2.h \
!   extract.h main.h image-header.h input-img.h input-pbm.h 
! image-char.o : image-char.c .././include/config.h .././include/c-auto.h .././include/c-std.h \
    .././include/c-memstr.h .././include/c-errno.h .././include/c-minmax.h .././include/c-limits.h \
    .././include/c-seek.h .././include/c-proto.h .././include/global.h .././include/lib.h \
!   .././include/types.h image-char.h 
  input-img.o : input-img.c .././include/config.h .././include/c-auto.h .././include/c-std.h \
    .././include/c-memstr.h .././include/c-errno.h .././include/c-minmax.h .././include/c-limits.h \
--- 3,17 ----
    .././include/c-seek.h .././include/c-proto.h .././include/global.h .././include/lib.h \
    .././include/types.h .././include/bitmap.h .././include/bounding-box.h bitmap2.h 
  extract.o : extract.c .././include/config.h .././include/c-auto.h .././include/c-std.h \
    .././include/c-memstr.h .././include/c-errno.h .././include/c-minmax.h .././include/c-limits.h \
    .././include/c-seek.h .././include/c-proto.h .././include/global.h .././include/lib.h \
!   .././include/types.h .././include/bitmap.h .././include/bounding-box.h .././include/report.h \
!   bitmap2.h extract.h main.h image-header.h input-img.h input-pbm.h 
! ifi.o : ifi.c .././include/config.h .././include/c-auto.h .././include/c-std.h \
    .././include/c-memstr.h .././include/c-errno.h .././include/c-minmax.h .././include/c-limits.h \
    .././include/c-seek.h .././include/c-proto.h .././include/global.h .././include/lib.h \
!   .././include/types.h .././include/encoding.h .././include/font.h .././include/bitmap.h \
!   .././include/bounding-box.h .././include/tfm.h .././include/fix-num.h .././include/list.h \
!   .././include/libfile.h ifi.h main.h image-header.h 
  input-img.o : input-img.c .././include/config.h .././include/c-auto.h .././include/c-std.h \
    .././include/c-memstr.h .././include/c-errno.h .././include/c-minmax.h .././include/c-limits.h \
***************
*** 30,39 ****
    .././include/c-seek.h .././include/c-proto.h .././include/global.h .././include/lib.h \
    .././include/types.h .././include/cmdline.h .././include/filename.h .././include/getopt.h \
!   .././include/gf.h .././include/bitmap.h .././include/bounding-box.h .././include/font.h \
!   .././include/tfm.h .././include/fix-num.h .././include/list.h .././include/libfile.h \
!   .././include/report.h .././include/bb-outline.h bitmap2.h .././include/encoding.h \
!   epsf.h image-header.h extract.h image-char.h input-img.h input-pbm.h main.h \
!   strips.h 
! strips.o : strips.c .././include/config.h .././include/c-auto.h .././include/c-std.h \
    .././include/c-memstr.h .././include/c-errno.h .././include/c-minmax.h .././include/c-limits.h \
    .././include/c-seek.h .././include/c-proto.h .././include/global.h .././include/lib.h \
--- 27,47 ----
    .././include/c-seek.h .././include/c-proto.h .././include/global.h .././include/lib.h \
    .././include/types.h .././include/cmdline.h .././include/filename.h .././include/getopt.h \
!   .././include/encoding.h .././include/font.h .././include/bitmap.h .././include/bounding-box.h \
!   .././include/tfm.h .././include/fix-num.h .././include/list.h .././include/gf.h \
!   .././include/report.h ifi.h image-header.h input-img.h input-pbm.h main.h out-chars.h \
!   out-epsf.h out-strips.h 
! out-chars.o : out-chars.c .././include/config.h .././include/c-auto.h .././include/c-std.h \
!   .././include/c-memstr.h .././include/c-errno.h .././include/c-minmax.h .././include/c-limits.h \
!   .././include/c-seek.h .././include/c-proto.h .././include/global.h .././include/lib.h \
!   .././include/types.h .././include/bb-outline.h .././include/bb-list.h .././include/bounding-box.h \
!   .././include/bitmap.h .././include/gf.h .././include/font.h .././include/tfm.h \
!   .././include/fix-num.h .././include/list.h .././include/report.h bitmap2.h extract.h \
!   ifi.h image-header.h main.h out-strips.h 
! out-epsf.o : out-epsf.c .././include/config.h .././include/c-auto.h .././include/c-std.h \
!   .././include/c-memstr.h .././include/c-errno.h .././include/c-minmax.h .././include/c-limits.h \
!   .././include/c-seek.h .././include/c-proto.h .././include/global.h .././include/lib.h \
!   .././include/types.h .././include/hexify.h .././include/report.h main.h image-header.h \
!   out-epsf.h 
! out-strips.o : out-strips.c .././include/config.h .././include/c-auto.h .././include/c-std.h \
    .././include/c-memstr.h .././include/c-errno.h .././include/c-minmax.h .././include/c-limits.h \
    .././include/c-seek.h .././include/c-proto.h .././include/global.h .././include/lib.h \
***************
*** 40,43 ****
    .././include/types.h .././include/gf.h .././include/bitmap.h .././include/bounding-box.h \
    .././include/font.h .././include/tfm.h .././include/fix-num.h .././include/list.h \
!   .././include/report.h input-img.h image-header.h input-pbm.h main.h strips.h 
  version.o : version.c 
--- 48,51 ----
    .././include/types.h .././include/gf.h .././include/bitmap.h .././include/bounding-box.h \
    .././include/font.h .././include/tfm.h .././include/fix-num.h .././include/list.h \
!   .././include/report.h main.h image-header.h out-strips.h 
  version.o : version.c 
diff -Nrc2 fontutils-0.5/imageto/bitmap2.c fontutils-0.6/imageto/bitmap2.c
*** fontutils-0.5/imageto/bitmap2.c	Mon Jun 15 07:57:07 1992
--- fontutils-0.6/imageto/bitmap2.c	Tue Sep 22 12:48:44 1992
***************
*** 41,45 ****
    DIMENSIONS_HEIGHT (new_dimens) = BITMAP_HEIGHT (b2);
    new = new_bitmap (new_dimens);
!   
    for (row = 0; row < BITMAP_HEIGHT (b2); row++)
      {
--- 41,46 ----
    DIMENSIONS_HEIGHT (new_dimens) = BITMAP_HEIGHT (b2);
    new = new_bitmap (new_dimens);
! 
!   /* Choice of `b2' or `b1' here is arbitrary, of course.  */
    for (row = 0; row < BITMAP_HEIGHT (b2); row++)
      {
diff -Nrc2 fontutils-0.5/imageto/extract.c fontutils-0.6/imageto/extract.c
*** fontutils-0.5/imageto/extract.c	Sat Jun 20 15:19:19 1992
--- fontutils-0.6/imageto/extract.c	Fri Oct  2 17:03:40 1992
***************
*** 23,26 ****
--- 23,27 ----
  #include "bitmap.h"
  #include "bounding-box.h"
+ #include "report.h"
  
  #include "bitmap2.h"
***************
*** 132,141 ****
     some kind of status report.  */
  
! #define REPORT_SCANLINE()						\
!   if (verbose && ++scanline_count % 100 == 0)				\
!     {									\
!       putc ('.', stderr);						\
!       fflush (stderr);							\
!     }
  
  /* Read scanlines of width WIDTH from the image file until we get one
--- 133,137 ----
     some kind of status report.  */
  
! #define REPORT_SCANLINE() if (++scanline_count % 100 == 0) REPORT (".")
  
  /* Read scanlines of width WIDTH from the image file until we get one
***************
*** 199,203 ****
          { /* Perhaps doubling is the wrong thing to do here, as it may
               waste quite a bit of memory.  But it's simple.  */
!           rows_allocated <<= 1;
            image = xrealloc (image, rows_allocated * width);
  	}
--- 195,199 ----
          { /* Perhaps doubling is the wrong thing to do here, as it may
               waste quite a bit of memory.  But it's simple.  */
!           rows_allocated += 100 /* ;<<= 1*/;
            image = xrealloc (image, rows_allocated * width);
  	}
diff -Nrc2 fontutils-0.5/imageto/ifi.c fontutils-0.6/imageto/ifi.c
*** fontutils-0.5/imageto/ifi.c
--- fontutils-0.6/imageto/ifi.c	Sat Oct 24 05:14:04 1992
***************
*** 0 ****
--- 1,197 ----
+ /* ifi.c: read an IFI file.  */
+ 
+ #include "config.h"
+ 
+ #include "encoding.h"
+ #include "libfile.h"
+ 
+ #include "ifi.h"
+ #include "main.h"
+ 
+ 
+ /* The name of the encoding file specified by the user, and the
+    structure we parse it into.  (-encoding)  */
+ string encoding_name = NULL;
+ 
+ /* The name of the IFI file.  (-ifi-file)  */
+ string ifi_filename = NULL;
+ 
+ 
+ static void append_image_char (image_char_list_type *l, image_char_type c);
+ static image_char_list_type new_image_char_list (void);
+ 
+ /* Read the IFI file `ifi_filename' (or construct the IFI filename from
+    `input_name'), which gives us information about the image we are
+    going to read.
+    
+    See the documentation for full details and examples of IFI files.
+    Here we just sketch the bare bones.
+    
+    Each (non-blank, non-comment) line in this file represents a
+    ``character'' in the image, and has one to five entries, separated by
+    spaces and/or tabs.  Comments start with `%' and continue to the end
+    of the line.
+    
+    The first entry represents the character code.  See the documentation
+    for the various forms of charcodes.  We also allow `.notdef', meaning
+    the ``character'' should not be output in the font.  
+    
+    The second entry, if it exists, is an adjustment to the
+    baseline.  We move the baseline down for negative numbers, and up
+    for positive ones.  Default is zero.
+    
+    The third entry, if it exists, is the number of bounding boxes that
+    comprise this character.  If it is negative, the bounding boxes
+    are not consecutive in the image; instead, they alternate with
+    bounding boxes for some other character.
+    
+    The fourth and fifth entries, if they exist, are the left and right
+    side bearings, respectively.  */
+    
+ image_char_list_type
+ read_ifi_file (unsigned *total_count)
+ {
+   string line;
+   int bb_count;
+   encoding_info_type *encoding_info;
+   int n = 0;
+   image_char_list_type image_char_list = new_image_char_list ();
+   
+   if (encoding_name)
+     {
+       encoding_info = XTALLOC1 (encoding_info_type);
+       *encoding_info = read_encoding_file (encoding_name);
+     }
+   else  
+     encoding_info = NULL;
+     
+   if (!ifi_filename)
+     ifi_filename = make_suffix (input_name, "ifi");
+ 
+   libfile_start (ifi_filename, "ifi");
+ 
+   *total_count = 0;
+ 
+   while ((line = libfile_line ()) != NULL)
+     {
+       image_char_type c;
+       string baseline_adjust_str, bb_count_str, charname;
+       string lsb_str, rsb_str;
+       string save_line = line; /* So we can free it.  */
+       
+       /* The character name.  */
+       charname = strtok (line, " \t");
+       
+       /* `libfile_line' should never return an empty line.  */
+       assert (charname != NULL);
+       
+       if (STREQ (charname, ".notdef"))
+         IMAGE_CHAR_OMIT (c) = true;
+       else
+         {
+           if (encoding_info)
+             n = encoding_number (*encoding_info, charname);
+           else
+             n++;
+           
+           if (n == -1)
+             {
+               LIBFILE_WARN2 ("Character `%s' undefined in encoding %s",
+                         charname, ENCODING_SCHEME_NAME (*encoding_info));
+               IMAGE_CHAR_OMIT (c) = true;
+ 	    }
+           else
+             {
+     	      IMAGE_CHARCODE (c) = n;
+               IMAGE_CHARNAME (c) = xstrdup (charname);
+               IMAGE_CHAR_OMIT (c) = false;
+ 	    }
+         }
+ 
+       /* The baseline adjustment.  */
+       baseline_adjust_str = strtok (NULL, " \t");
+       IMAGE_CHAR_BASELINE_ADJUST (c)
+         = baseline_adjust_str == NULL ? 0 : atoi (baseline_adjust_str);
+       
+       /* The bounding box count.  */
+       bb_count_str = strtok (NULL, " \t");
+       bb_count = bb_count_str == NULL ? 1 : atoi (bb_count_str);
+       
+       if (bb_count < 0)
+         {
+           IMAGE_CHAR_BB_COUNT (c) = -bb_count;
+           IMAGE_CHAR_BB_ALTERNATING (c) = true;
+         }
+       else
+         {
+           IMAGE_CHAR_BB_COUNT (c) = bb_count;
+           IMAGE_CHAR_BB_ALTERNATING (c) = false;
+         }
+ 
+       /* The left side bearing.  */
+       lsb_str = strtok (NULL, " \t");
+       IMAGE_CHAR_LSB (c) = lsb_str == NULL ? 0 : atoi (lsb_str);
+       
+       /* The right side bearing.  */
+       rsb_str = strtok (NULL, " \t");
+       IMAGE_CHAR_RSB (c) = rsb_str == NULL ? 0 : atoi (rsb_str);
+       
+       *total_count += IMAGE_CHAR_BB_COUNT (c);
+       append_image_char (&image_char_list, c);
+       free (save_line);
+     }
+   
+   libfile_close ();
+   if (encoding_info)
+     free (encoding_info);
+   
+   return image_char_list;
+ }
+ 
+ /* Return an initialized, empty list.  */
+ 
+ static image_char_list_type
+ new_image_char_list ()
+ {
+   image_char_list_type l;
+   
+   IMAGE_CHAR_LIST_LENGTH (l) = 0;
+   IMAGE_CHAR_LIST_DATA (l) = NULL;
+   
+   return l;
+ }
+ 
+ 
+ /* Append the character C to the list L.  */
+ 
+ void
+ append_image_char (image_char_list_type *l, image_char_type c)
+ {
+   IMAGE_CHAR_LIST_LENGTH (*l)++;
+   IMAGE_CHAR_LIST_DATA (*l)
+     = xrealloc (IMAGE_CHAR_LIST_DATA (*l),
+                   IMAGE_CHAR_LIST_LENGTH (*l) * sizeof (image_char_type));
+   IMAGE_CHAR (*l, IMAGE_CHAR_LIST_LENGTH (*l) - 1) = c;
+ }
+ 
+ 
+ /* Return false if the box BOX_COUNT boxes beyond FIRST_CHAR in LIST
+    is in the middle of a character, true otherwise.  To do this, we
+    add up all the box counts for characters starting at FIRST_CHAR,
+    until we see where we land.  */
+ 
+ boolean
+ box_at_char_boundary_p (image_char_list_type list, unsigned first_char,
+                         unsigned box_count)
+ {
+   unsigned count = 0;
+   
+   while (count < box_count && first_char < IMAGE_CHAR_LIST_LENGTH (list))
+     {
+       image_char_type c = IMAGE_CHAR (list, first_char);
+       count += IMAGE_CHAR_BB_COUNT (c);
+       first_char++;
+     }
+     
+   return count == box_count;
+ }
diff -Nrc2 fontutils-0.5/imageto/ifi.h fontutils-0.6/imageto/ifi.h
*** fontutils-0.5/imageto/ifi.h
--- fontutils-0.6/imageto/ifi.h	Fri Oct  2 17:13:40 1992
***************
*** 0 ****
--- 1,91 ----
+ /* ifi.h: information about the characters in the image.
+ 
+ Copyright (C) 1992 Free Software Foundation, Inc.
+ 
+ This program is free software; you can redistribute it and/or modify
+ it under the terms of the GNU General Public License as published by
+ the Free Software Foundation; either version 2, or (at your option)
+ any later version.
+ 
+ This program is distributed in the hope that it will be useful,
+ but WITHOUT ANY WARRANTY; without even the implied warranty of
+ MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ GNU General Public License for more details.
+ 
+ You should have received a copy of the GNU General Public License
+ along with this program; if not, write to the Free Software
+ Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.  */
+ 
+ #ifndef IFI_H
+ #define IFI_H
+ 
+ #include "types.h"
+ 
+ 
+ /* See ifi.c.  */
+ extern string encoding_name, ifi_filename;
+ 
+ 
+ /* A single character in the image.  */
+ typedef struct 
+ {
+   charcode_type charcode;
+   string charname;
+   boolean omit;
+   int baseline_adjust;
+   unsigned bb_count;
+   boolean alternating;
+   int lsb, rsb;
+ } image_char_type;
+ 
+ /* The character code.  This is garbage if `omit' is true.  */
+ #define IMAGE_CHARCODE(c) ((c).charcode)
+ 
+ /* The character name.  */
+ #define IMAGE_CHARNAME(c) ((c).charname)
+ 
+ /* Says whether this character should be output.  */
+ #define IMAGE_CHAR_OMIT(c) ((c).omit)
+ 
+ /* How far the baseline should be moved from the row's baseline.  */
+ #define IMAGE_CHAR_BASELINE_ADJUST(c) ((c).baseline_adjust)
+ 
+ /* How many bounding boxes comprise this character.  */
+ #define IMAGE_CHAR_BB_COUNT(c) ((c).bb_count)
+ 
+ /* Says whether the bounding boxes in this character are consecutive
+    (the usual case) or alternate.  */
+ #define IMAGE_CHAR_BB_ALTERNATING(c) ((c).alternating)
+ 
+ /* The side bearings.  */
+ #define IMAGE_CHAR_LSB(c) ((c).lsb)
+ #define IMAGE_CHAR_RSB(c) ((c).rsb)
+ 
+ 
+ /* A list of the above.  */
+ typedef struct
+ {
+   image_char_type *data;
+   unsigned length;
+ } image_char_list_type;
+ 
+ /* The Nth element of the list L.  */
+ #define IMAGE_CHAR(l, n) ((l).data[n])
+ 
+ /* The list as a whole.  */
+ #define IMAGE_CHAR_LIST_DATA(l) ((l).data)
+ 
+ /* The length of the list.  */
+ #define IMAGE_CHAR_LIST_LENGTH(l) ((l).length)
+ 
+ 
+ /* Read the IFI file IFI_FILENAME. Return the total number of characters
+    read in TOTAL_COUNT.  */
+ extern image_char_list_type read_ifi_file (unsigned *total_count);
+ 
+ /* Return false if the box BOX_COUNT boxes beyond FIRST_CHAR in LIST
+    is in the middle of a character, true otherwise.  */
+ extern boolean box_at_char_boundary_p
+   (image_char_list_type list, unsigned first_char, unsigned box_count);
+ 
+ #endif /* not IFI_H */
